"""
Requirements:
    Să se scrie un program care permite oricare din următoarele operații:
        a. construirea unui șir cu numere naturale ex. șir = (5, 9, 14, 7)
        b. afișarea unui șir cu numere naturale 
        c. determinarea sumei elementelor din șir care sunt pătrate perfecte
        ex. dacă șir = (5, 9, 14, 7), atunci suma este 13 = 9 + 4
        d. filtrarea elementelor din șir care sunt pătrate perfecte
        ex. dacă șir = (5, 9, 4, 7), atunci șir' = (5, 7)
        e. deplasarea la începutul șirului a celei mai lungi secvențe de numere pătrate
        perfecte
        ex. dacă șir = (5, 9, 4, 7, 16, 36, 4, 6), atunci șir' = (16, 36, 4, 5, 9, 4, 7, 6)
    
"""

def maxSeqPS(sir):
    '''
    Afla cea mai lunga secventa de numere patrate perfecte
    Args: sir (list) - sirul de numere
    Returns: s, f - index start, finish
    '''
    s = f = -1
    l = l_max = 0
    j = 0
    for i in range(len(sir)):
        if (isPerfectSquare(sir[i])):
            l = 1
            j = i+1
            while (isPerfectSquare(sir[j]) and j < len(sir)):
                l += 1
                j += 1
            if (l > l_max):
                s = i
                f = j-1
                l_max = l
        i = j
    return s, f

def testMaxSeqPS():
    assert maxSeqPS([1, 5, 4, 9, 13, 16, 25, 36, 48]) == (5, 7)
    assert maxSeqPS([2, 5, 8, 13]) == (-1, -1)
    assert maxSeqPS([9, 13, 18]) == (0, 0)
    print ("maxSeqPS is ok")

def moveMaxSeqPS(sir):
    '''
    Deplaseaza la inceputul sirului cea mai lunga secventa de numere patrate perfecte
    '''
    

def display(sir):
    '''
    Afiseaza un sir de elemente
    Args: sir(list) - sirul de numere
    '''
    print("sirul este: ",end="")
    for x in sir:
        print(x,end=" ")
    #print("Sirul este:\t", sir)
    

def isPerfectSquare(nr):
    '''
    Verifica daca un numar este patrat perfect
    Args: nr(natural) - numarul care va fi verificat
    Returns: True - daca e patrat perfect , False - daca nu e patrat perfect
    '''
    n=0
    while(n*n<=nr):
        if(n*n==nr):
            return True
        n+=1
    return False
        
    #if nr**0.5==int(nr**0.5):
    #    return True
    #return False

def testIsPerfectSquare():
    assert isPerfectSquare(9) == True
    assert isPerfectSquare(5) == False
    assert isPerfectSquare(121) == True
    assert isPerfectSquare(0) == True
    assert isPerfectSquare(8) == False
    print("isPerfectSquare has passed all the tests!")

def sumPerfectSquares(sir):
    '''
    Efectueaza suma tuturor patratelor perfecte din sirul dat
    Args: sir(list) - sirul de numere
    Returns: suma
    '''
    sum=0
    for x in sir:
        if isPerfectSquare(x):
            sum+=x
    return sum

def testSumPerfectSquares():
    assert sumPerfectSquares([1,6,8,121,25]) == 147
    assert sumPerfectSquares([2,4,8,16]) == 20
    assert sumPerfectSquares([4,9,4,9,5]) == 26
    assert sumPerfectSquares([]) == 0
    print("sumPerfectSquares has passed the tests")

def filterPerfectSquares(sir):
    '''
    Elimina numerele care sunt patrate perfecte din sir
    Args: sir(list): sirul dat de numere
    Returns sirFiltrat(list): sirul nou 
    '''
    sirFiltrat=[] 
    for x in sir:
        if not(isPerfectSquare(x)):
            sirFiltrat.append(x)
    return(sirFiltrat)

def filterPerfectSquares_v2(sir):
    '''
    Elimina numerele care sunt patrate perfecte din sir
    Args: sir(list): sirul dat de numere
    Returns sirFiltrat(list): sirul nou 
    '''
    i = 0
    while(i < len(sir)):
        print(sir)
        if (isPerfectSquare(sir[i])):
            sir.pop(i)
        else:
            i += 1
    return sir

def testFilterPerfectSquares_v2():
    assert filterPerfectSquares_v2([1, 5, 9, 8, 13, 16]) == [5, 8, 13]
    assert filterPerfectSquares_v2([4, 7, 19, 10, 36]) == [7, 19, 10]
    assert filterPerfectSquares_v2([7, 18, 22, 21, 30]) == [7, 18, 22, 21, 30]
    assert filterPerfectSquares_v2([9, 16, 25, 36]) == []
    print("filterPerfectSquares v2 has passed all the tests")

def testFilterPerfectSquares():
    assert filterPerfectSquares([1,2,3,4,9])==[2,3]
    assert filterPerfectSquares([5,7])==[5,7]
    print("filterPerfectSquares has passed all the tests")
        

def readAndAdd(sir):
    '''
    Citeste numere de la tastatura pana la intalnirea valorii 0.
    Input-urile invalide nu sunt luate in considerare.
    Args: sir(list) - sirul deja existent.
    Returns: Sirul cu numerele valide adaugate.
    '''
    print("intorduceti numere. Iesiti cu 0 ")
    n=''
    while n!='0':
        n=input("Dati un numar: ")
        if isNatural(n) == True :
            if int(n)>0:
                sir.append(int(n))
        else:
            print("Ati introdus ceva invalid!")
    return sir

def isNatural(nr):
    '''
    Verifica daca un numar este natural.
    Args: nr(string) - numarul care se verifica sub forma de 
    Returns: True daca numarul este natural
             False daca numarul nu este natural sau input-ul este invalid
    '''
    try:   
        if int(nr)>=0 and float(nr).is_integer():
            return True
        return False
    except ValueError:     
        return False

    
def runMenu():
    pass

def testIsNatural():

    assert isNatural(2) == True
    assert isNatural(5) == True
    assert isNatural(-3) == False
    assert isNatural(0) == True
    assert isNatural(3.5) == False
    assert isNatural("x") == False
    print("Testele la isNatural au trecut")

def run():

    sir=[]
    testIsNatural()
    testIsPerfectSquare()
    testSumPerfectSquares()
    testFilterPerfectSquares_v2()
    testFilterPerfectSquares()
    sir=readAndAdd(sir)
    display(sir)
    print(sumPerfectSquares(sir))
    sir=filterPerfectSquares(sir)
    
    display(sir)

#run()

testMaxSeqPS()
